import io from 'socket.io-client';
const address: any = import.meta.env.VITE_APP_BASE_API;
const token: any = localStorage.getItem('token');
let socket: any = {}; //ws实例对象

export const handWs = (callback: any) => {
  socket = io(address + '/', {
    transports: ['websocket', 'polling'],
    query: {
      Authorization: token
    }
  });
  socket.on('connect', (e: any) => {
    sendMessage(
      'handcontroller',
      {
        hctrl_name: 'handcontroller_2',
        cmd: 'open_handcontroller'
      },
      () => {}
    );
  });

  socket.on('handcontroller_ack', (e: any) => {
    callback(e);
    if (e.code == 94210) {
      sendMessage(
        'handcontroller',
        {
          hctrl_name: 'handcontroller_2',
          cmd: 'terminate_handcontroller'
        },
        () => {}
      );
    }
  });

  socket.on('handcontroller_result', (e: any) => {
    callback(e);
  });

  socket.on('disconnect', (e: any) => {});
};

export const sendMessage = (type: string, data: any, callback?: () => void) => {
  if (socket.connected) {
    callback = callback || function () {};
    socket.emit(type, data, callback);
  }
};
